# $Revision: 1.19 $, $Date: 2010/04/20 14:59:08 $
# TODO:
# - use more system packages? (jarjar, lib/integration/*)
# - build javadoc (now it fails)
# - does not build with gcj.
#
# Conditional build:
%bcond_without	javadoc		# build javadoc
%bcond_with	tests		# build and run tests (tests are broken)
%bcond_with binary		# do not compile .jars from source use bundled ones
%bcond_with	bootstrap	# break BR loop (java-junit, java-qdox)

%if %{with bootstrap}
%define		with_binary	1
%undefine	with_tests
%undefine	with_javadoc
%endif

%define		rel	2
%define		srcname	hamcrest
%include	/usr/lib/rpm/macros.java
Summary:	Hamcrest - a library of matchers
Summary(pl.UTF-8):	Hamcrest - biblioteka klas dopasowujących
Name:		java-hamcrest
Version:	1.2
Release:	%{bootstrap_release %rel}
License:	BSD
Group:		Libraries/Java
Source0:	http://hamcrest.googlecode.com/files/%{srcname}-%{version}.tgz
# Source0-md5:	b4bd43f44d082d77daf7ec564d304cdf
Patch0:		%{srcname}-nosrc.patch
Patch1:		javadoc-build.patch
URL:		http://code.google.com/p/hamcrest/
%if %{without binary}
BuildRequires:	ant >= 1.6
%{?with_tests:BuildRequires:	ant-junit >= 1.6}
%{?with_tests:BuildRequires:	java-junit}
BuildRequires:	java-qdox
BuildRequires:	jdk
%endif
BuildRequires:	jpackage-utils
BuildRequires:	rpm-javaprov
BuildRequires:	rpmbuild(macros) >= 1.557
Requires:	java-qdox
Requires:	jpackage-utils
Obsoletes:	hamcrest
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Hamcrest is a library of matchers, which can be combined in to create
flexible expressions of intent in tests.

%description -l pl.UTF-8
Hamcrest to biblioteka klas dopasowujących, które można łączyć w celu
utworzenia elastycznych wyrażeń do wykorzystania w testach.

%package javadoc
Summary:	Javadoc manual for hamcrest
Summary(pl.UTF-8):	Dokumentacja javadoc do hamcresta
Group:		Documentation
Requires:	jpackage-utils
Obsoletes:	hamcrest-javadoc

%description javadoc
Javadoc manual for hamcrest.

%description javadoc -l pl.UTF-8
Dokumentacja javadoc do hamcresta.

%package source
Summary:	Source code of %{srcname}
Summary(pl.UTF-8):	Kod źródłowy %{srcname}
Group:		Documentation
Requires:	jpackage-utils >= 1.7.5-2

%description source
Source code of %{srcname}.

%description source -l pl.UTF-8
Kod źródłowy %{srcname}.

%prep
%setup -q -n %{srcname}-%{version}
%patch0 -p0
%patch1 -p0

rm -vf lib/integration/junit-*.jar
rm -vf lib/generator/qdox-*.jar

%if %{without binary}
rm -vf *.jar
%endif

# TODO: add new property (with this default value) do be override with -D
# TODO: add build.properties support to build.xml
%{__sed} -i -e 's,lib/generator/qdox-1.6.1.jar,${qdox.jar},g' build.xml

%build
export JAVA_HOME="%{java_home}"

%if %{with binary}
install -d build
cp -af *.jar build
%else
qdox_jar=$(find-jar qdox)
CLASSPATH=$qdox_jar
cat <<EOF > build.properties
qdox.jar=$qdox_jar
EOF

%ant core generator library integration \
	-Dqdox.jar=$qdox_jar \
	-Dversion=%{version}
%endif

%if %{with javadoc}
# doesn't build
%ant javadoc \
	-Dqdox.jar=$qdox_jar \
	-Dversion=%{version}
%endif

%if %{with tests}
%ant unit-test \
	-Dqdox.jar=$qdox_jar \
	-Dversion=%{version}
%endif

# source
%jar cf %{srcname}.src.jar -C build/temp/hamcrest-library/generated-code .
%jar uf %{srcname}.src.jar -C build/temp/hamcrest-core/generated-code .
for I in examples integration library generator core; do
	%jar uf %{srcname}.src.jar -C hamcrest-$I/src/main/java .
done

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_javadir}

for f in core generator integration library; do
	cp -a build/hamcrest-$f-%{version}.jar $RPM_BUILD_ROOT%{_javadir}
	ln -sf hamcrest-$f-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/hamcrest-$f.jar
done

%if %{with javadoc}
# javadoc
install -d $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
cp -a build/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{srcname}-%{version}
ln -s %{srcname}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{srcname} # ghost symlink
%endif

#source
install -d $RPM_BUILD_ROOT%{_javasrcdir}
cp -a %{srcname}.src.jar $RPM_BUILD_ROOT%{_javasrcdir}/%{srcname}.src.jar

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
ln -nfs %{srcname}-%{version} %{_javadocdir}/%{srcname}

%files
%defattr(644,root,root,755)
%doc CHANGES.txt LICENSE.txt README.txt
%{_javadir}/*.jar

%if %{with javadoc}
%files javadoc
%defattr(644,root,root,755)
%{_javadocdir}/%{srcname}-%{version}
%ghost %{_javadocdir}/%{srcname}
%endif

%files source
%defattr(644,root,root,755)
%{_javasrcdir}/%{srcname}.src.jar
%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)

%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: java-hamcrest.spec,v $
Revision 1.19  2010/04/20 14:59:08  pawelz
- fixed jpackage-utils dep

Revision 1.18  2010/04/20 09:56:26  pawelz
- O: hamcrest (it was sent to ti builders before rename to java-hamcrest)

Revision 1.17  2010/04/20 09:23:42  pawelz
- fix build javadoc and enable it by default
- build src jar and package it as -source subpackage

Revision 1.16  2010/04/19 20:10:40  pawelz
- up to 1.2
- use our new cool %bootstrap_release macro
- disable tests. They don't build. It is problem with tests, not with tested code

Revision 1.15  2010/04/18 14:47:27  pawelz
- don't add .bootstrap to rel. x.bootstrap > x.
- don't force specific jdk
- sorted BRs

Revision 1.14  2009/08/20 11:22:24  pawelz
- rel 3

Revision 1.13  2009/08/19 13:42:05  pawelz
- don't search for build dependencies when being built with binary

Revision 1.12  2009/08/19 13:25:35  pawelz
- with_bootstrap implies without_tests and without_javadoc

Revision 1.11  2009/08/19 13:00:08  pawelz
- do not BR ant, junit, qdox when being built with binary

Revision 1.10  2009/08/19 12:20:07  pawelz
- drop hack for archs where java-sun is not available
- bootstrap bcond

Revision 1.9  2009/05/21 17:23:29  glen
- when using java_sun, use binary jars where java-sun is not available; rel 2

Revision 1.8  2009/05/20 07:06:00  glen
- release 1

Revision 1.7  2009/04/13 16:44:24  glen
- do a clean build
- don't package -all.jar

Revision 1.6  2009/04/13 14:52:49  pawelz
- added TODO (does not build with gcj)
- dropped patch1

Revision 1.5  2009/04/13 14:41:50  pawelz
- fixed %setup

Revision 1.4  2009/04/13 14:30:37  pawelz
- typo (define srcname)
- G: Libraries/Java
- one BR: java-sun is enough

Revision 1.3  2009/04/13 14:24:51  pawelz
- renamed from hamcrest
- BR: java-sun when being built with java_sun
- '#' is not a comment in spec file

Revision 1.2  2009/04/03 15:53:56  pawelz
- jdk bconds
- dropped EA
- use system qdox

Revision 1.1  2007/09/09 09:28:03  qboosh
- new
